
#pip install win32com

#sample using the activex client ./IDASrvr2/ActiveX_clientLib/IDAClientLib2.dll
#(must be registered from a 32bit admin cmd.exe)
#not my favorite from python com methods are being weird returning tuples?

import win32com.client as win32
import win32con, win32api, win32gui, ctypes, ctypes.wintypes, sys, struct
from array import array

WM_DISPLAY_TEXT = 3

class COPYDATASTRUCT(ctypes.Structure):
    _fields_ = [
        ('dwData', ctypes.wintypes.LPARAM),
        ('cbData', ctypes.wintypes.DWORD),
        ('lpData', ctypes.c_void_p)
    ]
PCOPYDATASTRUCT = ctypes.POINTER(COPYDATASTRUCT)

class Listener:
    # https://stackoverflow.com/questions/5249903/receiving-wm-copydata-in-python   
    def __init__(self):
        message_map = {}
        #    win32con.WM_COPYDATA: self.OnCopyData
        #}
        wc = win32gui.WNDCLASS()
        wc.lpfnWndProc = message_map
        wc.lpszClassName = 'MyWindowClass'
        hinst = wc.hInstance = win32api.GetModuleHandle(None)
        classAtom = win32gui.RegisterClass(wc)
        self.hwnd = win32gui.CreateWindow (
            classAtom,
            "win32gui test",
            0,
            0, 
            0,
            win32con.CW_USEDEFAULT, 
            win32con.CW_USEDEFAULT,
            0, 
            0,
            hinst, 
            None
        )
        #print("Python listening for WM_COPYDATA on hwnd = %d" % self.hwnd)
        
        '''   def OnCopyData(self, hwnd, msg, wparam, lparam):
                print("Copy data msg received! hwnd=%d msg=0x%x wparam=0x%x lparam=0x%x" % (hwnd,msg,wparam,lparam))
                pCDS = ctypes.cast(lparam, PCOPYDATASTRUCT)
                if pCDS.contents.dwData != WM_DISPLAY_TEXT:
                    print( "Not WM_DISPLAY_TEXT dwData=%d cbData=0x%x lpData=0x%x" % (pCDS.contents.dwData,pCDS.contents.cbData,pCDS.contents.lpData))
                    return
                
                print("WM_DISPLAY_TEXT received cbData=0x%x lpData=0x%x" % (pCDS.contents.cbData,pCDS.contents.lpData))
                msg = ctypes.string_at(pCDS.contents.lpData)
                recvCommand(msg)
                return 1
        '''

myWindow = Listener()
print("myWindow.hwnd = " + str(myWindow.hwnd))

ida = win32.Dispatch("IDAClientLibrary2.CIDAClient2")
ida.ipc.Listen(myWindow.hwnd)
h = ida.SelectServer()
print("ida.hwnd = " + str(h[0])) #not sure why its returning tuples..
ida.ipc.RemoteHWND = int(h[0])

print("loadedfile: " + ida.loadedfile)
va = ida.functionStart(0)
print("ida.functionStart(0) = %x" % va[0])
print("1st inst: %s" % ida.getAsm(va[0])[0])