/*
    Function md5File(fpath)
    Function md5(str)
    Function hexdump(str)
    Function rc4(str, pass)
    Function writeBin(fpath, data)
    Function getBin(fpath,offset,leng)
    
*/    

function cryptClass(){

	this.hInst = 0
    
    this.md5File = function(fpath){
		return resolver('crypt.md5File', arguments.length,0, fpath);
	}
    
    this.md5 = function(str){
        var str = this.toHexStr(str)
		return resolver('crypt.md5', arguments.length,0, str);
	}
    
    this.writeBin = function(path,data){
        var data = this.toHexStr(data)
		return resolver('crypt.writeBin', arguments.length,0, path, data);
	}
    
    this.getBin = function(path, offset, leng){
        if(path === undefined) path = ''
        if(offset === undefined) offset = -1
        if(leng === undefined) leng = -1
		var ret = resolver('crypt.getBin', 3,0,path,offset,leng); //always 3 args last 2 optional
        //alert(ret.length % 2 + "\n" + ret)
        return this.fromHexStr(ret)
        //return ret
	}
    
    this.rc4 = function(str,pass){
        var str = this.toHexStr(str)
        var pass = this.toHexStr(pass)
		var ret = resolver('crypt.rc4', arguments.length,0, str, pass);
        return this.fromHexStr(ret)
	}
    
    this.hexdump = function(str){
        var str = this.toHexStr(str)
		return resolver('crypt.hexdump', arguments.length,0, str);
	}
    
    this.crc32=function(r){for(var a,o=[],c=0;c<256;c++){a=c;for(var f=0;f<8;f++)a=1&a?3988292384^a>>>1:a>>>1;o[c]=a}for(var n=-1,t=0;t<r.length;t++)n=n>>>8^o[255&(n^r.charCodeAt(t))];return(-1^n)>>>0};

    this.toHexStr = function(tmp){
        var str = '';
        for(var i = 0; i < tmp.length; i++) {
            str += ('0' + tmp[i].charCodeAt(0).toString(16)).slice(-2);
        }
        return str;
    }
    
    this.fromHexStr = function(hexStr){
        hexStr = hexStr.trim()
        var str = '';
        for (var i = 0; i < hexStr.length; i += 2){
            try{
                var hc = "0x" + hexStr.substr(i, 2)
                /*if(hc == "09"){ //parse int doesnt like the lead 0..
                    alert(parseInt(hc, 16))
                }*/
                str += String.fromCharCode(parseInt(hc));
            }catch(e){
                alert("Error in fromHexStr: " + e + "\ni=" + i + "\nhexStr:\n"+ hexStr)
                return hexStr
            }
        }
        return str;
    }

}

var crypt = new cryptClass()