VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmSelect 
   Caption         =   "Select IDA Server to Connect to"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6150
   LinkTopic       =   "Form2"
   ScaleHeight     =   3195
   ScaleWidth      =   6150
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.ListView lv 
      Height          =   2475
      Left            =   60
      TabIndex        =   1
      Top             =   60
      Width           =   5955
      _ExtentX        =   10504
      _ExtentY        =   4366
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Bits"
         Object.Width           =   1235
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "IDAVer"
         Object.Width           =   1235
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "File"
         Object.Width           =   4410
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Path"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.CommandButton cmdSelect 
      Caption         =   "Select"
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   4500
      TabIndex        =   0
      Top             =   2700
      Width           =   1515
   End
End
Attribute VB_Name = "frmSelect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Function SelectIDAInstance(ida As CIDAScript, Optional refresh As Boolean = True, Optional autoSelectIfOnlyOne As Boolean = True, Optional alertIfNone As Boolean = False) As Long
    
    Dim x
    Dim cnt As Long
    Dim pth As String, fname As String
    Dim ver As String, bits As String
    Dim li As ListItem
    
    On Error Resume Next
    
    If refresh Then
        cnt = ida.ipc.FindActiveIDAWindows()
    Else
        cnt = ida.ipc.Servers.count
    End If
    
    If cnt = 0 Then
        If alertIfNone Then MsgBox "No open IDASrvr2 Instances found", vbInformation
        SelectIDAInstance = 0
        Unload Me
        Exit Function
        
    ElseIf cnt = 1 And autoSelectIfOnlyOne Then
        'MsgBox "Only 1"
        SelectIDAInstance = ida.ipc.Servers(1)
        Unload Me
        Exit Function
        
    Else
       For Each x In ida.ipc.Servers 'remove any that arent still valid..
            If IsWindow(x) = 0 Then
                ida.ipc.Servers.Remove "hwnd:" & x
            Else
                ida.ipc.RemoteHWND = CLng(x)
                ver = ida.version
                bits = ida.bits
                pth = ida.loadedFile
                fname = fso.FileNameFromPath(pth)
                'List1.AddItem Join(Array(X, bits, ver, pth), ": ")
                Set li = lv.ListItems.add(, , bits)
                li.SubItems(1) = ver
                li.SubItems(2) = fname
                li.SubItems(3) = fso.GetParentFolder(pth)
                li.Tag = x
            End If
        Next
    End If
    
    Me.Show 1 ', frmMain  'modal - execution hangs here until this form is hidden
    
'    Dim sel
'    sel = List1.List(List1.ListIndex)
'    a = InStr(sel, ":")
'    If a > 0 Then
'        sel = Mid(sel, 1, a - 1)
'    End If
    
    If lv.SelectedItem Is Nothing Then Exit Function

    SelectIDAInstance = CLng(lv.SelectedItem.Tag)
    Unload Me
    
End Function

Private Sub cmdSelect_Click()
    Me.Hide
End Sub

Private Sub Form_Load()
    On Error Resume Next
    'Me.Icon = frmMain.Icon
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    lv.Width = Me.Width - lv.Left - 400
    lv.Height = Me.Height - lv.Top - 800 - cmdSelect.Height
    cmdSelect.Top = Me.Height - cmdSelect.Height - 750
    cmdSelect.Left = Me.Width - cmdSelect.Width - 400
    lv.ColumnHeaders(4).Width = lv.Width - lv.ColumnHeaders(4).Left
End Sub

Private Sub lv_DblClick()
    If Not lv.SelectedItem Is Nothing Then Me.Hide
End Sub
