[Setup]
AppName=IDA_JScript2
AppVerName=IDA_JScript2 (IDA 7+)
DefaultDirName=c:\Sandsprite\IDA_JScript2
DefaultGroupName=IDA_JScript2
UninstallDisplayIcon={app}\unins000.exe
OutputDir=./
OutputBaseFilename=IDAJS_2_Setup

[Messages]
FinishedLabel=Remember to install the IDA plugins!.

[Run]
Filename: {app}\IDA_JScript.exe; Parameters: /install; StatusMsg: Installing plw and setting registry keys

[Dirs]
Name: {app}\COM
Name: {app}\scripts
Name: {app}\compare
Name: {app}\compare\db
Name: {app}\compare\WinMerge_Plugin
Name: {app}\Ollysync
Name: {app}\gleegraph
Name: {app}\IDASrvr2\ActiveX_clientLib
Name: {app}\IDASrvr2\ActiveX_clientLib2
Name: {app}\IDASrvr2\v7_plugin\bin\
Name: {app}\IDASrvr2\v8_plugin\bin\
Name: {app}\IDASrvr2\v9_plugin\bin\

[Files]
Source: ./dependancies\Duk4VB.dll; DestDir: {app}; Flags: replacesameversion
Source: ./dependancies\dukDbg.ocx; DestDir: {app}; Flags: regserver replacesameversion
Source: ./dependancies\spSubclass.dll; DestDir: {app}; Flags: regserver
Source: ./dependancies\vbUtypes.dll; DestDir: {app}; Flags: regserver
Source: ./dependancies\sppe3.dll; DestDir: {app}; Flags: regserver
Source: ./dependancies\SciLexer.dll; DestDir: {app}; Flags: replacesameversion
Source: ./dependancies\scivb2.ocx; DestDir: {app}; Flags: regserver   replacesameversion
Source: ./dependancies\UTypes.dll; DestDir: {app}; Flags: replacesameversion
Source: ./dependancies\MSCOMCTL.OCX; DestDir: {win}; Flags: regserver uninsneveruninstall
Source: ./dependancies\richtx32.ocx; DestDir: {sys}; Flags: regserver uninsneveruninstall
Source: ./dependancies\MSWINSCK.OCX; DestDir: {sys}; Flags: regserver uninsneveruninstall
;Source: dependancies\vbUtypes.dll; DestDir: {app}; Flags: regserver replacesameversion --> ULong64.cls now internal (now req by sppe3.dll)
Source: dependancies\vbDevKit.dll; DestDir: {app}; Flags: regserver
Source: ./IDASrvr2\v7_plugin\bin\IDASvr7.dll; DestDir: {app}\IDASrvr2\v7_plugin\bin\
Source: ./IDASrvr2\v7_plugin\bin\IDASvr7_64.dll; DestDir: {app}\IDASrvr2\v7_plugin\bin\
Source: ./IDASrvr2\v8_plugin\bin\IDASvr8.dll; DestDir: {app}\IDASrvr2\v8_plugin\bin\
Source: ./IDASrvr2\v8_plugin\bin\IDASvr8_64.dll; DestDir: {app}\IDASrvr2\v8_plugin\bin\
Source: ./IDASrvr2\v9_plugin\bin\IDASvr9.dll; DestDir: {app}\IDASrvr2\v9_plugin\bin\
Source: ./COM\ida.js; DestDir: {app}\COM\
Source: ./COM\x64.js; DestDir: {app}\COM\
Source: ./COM\list1.js; DestDir: {app}\COM\
Source: ./COM\TextBox.js; DestDir: {app}\COM\
Source: ./COM\remote.js; DestDir: {app}\COM\
Source: ./COM\al.js; DestDir: {app}\COM\
Source: ./COM\pb.js; DestDir: {app}\COM\
Source: ./COM\crypt.js; DestDir: {app}\COM\
;Source: ..\scripts\funcCalls.idajs; DestDir: {app}\scripts\
Source: IDA_JScript.exe; DestDir: {app}; Flags: replacesameversion
Source: objBrowser.exe; DestDir: {app}; Flags: replacesameversion
Source: api.txt; DestDir: {app}
Source: beautify.js; DestDir: {app}
Source: java.hilighter; DestDir: {app}
Source: userlib.js; DestDir: {app}
;Source: readme.txt; DestDir: {app}
Source: ./scripts\cur_func_bytes.idajs; DestDir: {app}\scripts\
Source: ./scripts\emit_cur_func.idajs; DestDir: {app}\scripts\
Source: ./scripts\emit_with_disasm.idajs; DestDir: {app}\scripts\
Source: ./scripts\extractFuncNames.idajs; DestDir: {app}\scripts\
Source: ./scripts\extractNamesRange.idajs; DestDir: {app}\scripts\
Source: ./scripts\extractNamesRange2.idajs; DestDir: {app}\scripts\
Source: ./scripts\funcCalls.idajs; DestDir: {app}\scripts\
Source: ./scripts\prefix_small.idajs; DestDir: {app}\scripts\
Source: ./scripts\user_funcs.idajs; DestDir: {app}\scripts\
Source: ./scripts\readString.idajs; DestDir: {app}\scripts\
Source: ./scripts\ollyDisasmJump.idajs; DestDir: {app}\scripts\
Source: ./scripts\xref_count.idajs; DestDir: {app}\scripts\
Source: ./scripts\regex.idajs; DestDir: {app}\scripts\
Source: ./scripts\resources.idajs; DestDir: {app}\scripts\
Source: ./scripts\prefix_func_xrefs.idajs; DestDir: {app}\scripts\
Source: ./scripts\extract_guid.idajs; DestDir: {app}\scripts\
Source: compare\db\blank.db; DestDir: {app}\compare\db
Source: compare\db\mydoom_example.db; DestDir: {app}\compare\db
Source: compare\db\signatures.db; DestDir: {app}\compare\db
Source: compare\WinMerge_Plugin\wmIDACompare.dll; DestDir: {app}\compare\WinMerge_Plugin; Flags: regserver
Source: compare\crc32.dll; DestDir: {app}\compare\
Source: compare\ida_compare.exe; DestDir: {app}\compare\
Source: compare\Readme.chm; DestDir: {app}\compare\
Source: compare\README.txt; DestDir: {app}\compare\
Source: Ollysync\AxOllySync.dll; DestDir: {app}\Ollysync\; Flags: regserver
Source: Ollysync\ollysync.dll; DestDir: {app}\Ollysync\
Source: Ollysync\README.txt; DestDir: {app}\Ollysync\
Source: IDASrvr2\ActiveX_clientLib\IDAClientLib2.dll; DestDir: {app}\IDASrvr2\ActiveX_clientLib\ ; Flags: regserver
Source: IDASrvr2\ActiveX_clientLib\UTypes.dll; DestDir: {app}\IDASrvr2\ActiveX_clientLib\
Source: IDASrvr2\ActiveX_clientLib2\IDAClientLib2b.dll; DestDir: {app}\IDASrvr2\ActiveX_clientLib2\ ; Flags: regserver
Source: IDASrvr2\ActiveX_clientLib2\UTypes.dll; DestDir: {app}\IDASrvr2\ActiveX_clientLib2\
Source: gleegraph\Microsoft.GLEE.dll; DestDir: {app}\gleegraph\
Source: gleegraph\Microsoft.GLEE.Drawing.dll; DestDir: {app}\gleegraph\
Source: gleegraph\Microsoft.GLEE.GraphViewerGDI.dll; DestDir: {app}\gleegraph\
Source: gleegraph\qwingraph.exe; DestDir: {app}\gleegraph\

[Icons]
Name: {group}\IDA Jscript; Filename: {app}\IDA_JScript.exe
Name: {group}\Object Browser; Filename: {app}\objBrowser.exe
Name: {group}\IDA Compare; Filename: {app}\compare\ida_compare.exe
Name: {group}\Uninstall; Filename: {app}\unins000.exe
Name: {group}\Readme.txt; Filename: {app}\readme.txt
;Name: {userdesktop}\IDA_Jscript; Filename: {app}\IDA_Jscript.exe; IconIndex: 0

