VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmImporter 
   Caption         =   "IDA Compare DB Importer (requires IDASvr2 plugin installed and IDA 7+ open)"
   ClientHeight    =   6240
   ClientLeft      =   60
   ClientTop       =   645
   ClientWidth     =   12270
   Icon            =   "frmIDACompare.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6240
   ScaleWidth      =   12270
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdSelectIDB 
      Caption         =   "..."
      Height          =   345
      Left            =   9420
      TabIndex        =   15
      Top             =   60
      Width           =   735
   End
   Begin VB.TextBox txtIDB 
      Height          =   315
      Left            =   1140
      Locked          =   -1  'True
      TabIndex        =   14
      Top             =   60
      Width           =   8175
   End
   Begin VB.CommandButton cmdAbort 
      Caption         =   "abort"
      Height          =   330
      Left            =   11220
      TabIndex        =   12
      Top             =   540
      Width           =   780
   End
   Begin IDACompare.ucFilterList lv 
      Height          =   4785
      Left            =   2115
      TabIndex        =   11
      Top             =   1230
      Width           =   10005
      _ExtentX        =   17648
      _ExtentY        =   8440
   End
   Begin MSComctlLib.ProgressBar pb 
      Height          =   255
      Left            =   2115
      TabIndex        =   7
      Top             =   960
      Width           =   10035
      _ExtentX        =   17701
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton cmdSelect 
      Caption         =   "..."
      Height          =   345
      Left            =   9420
      TabIndex        =   5
      Top             =   540
      Width           =   735
   End
   Begin VB.CommandButton cmdNew 
      Caption         =   "new"
      Height          =   345
      Left            =   10320
      TabIndex        =   3
      Top             =   540
      Width           =   735
   End
   Begin VB.TextBox txtDB 
      Height          =   315
      Left            =   1125
      OLEDropMode     =   1  'Manual
      TabIndex        =   2
      Top             =   480
      Width           =   8205
   End
   Begin VB.Frame Frame1 
      Height          =   2970
      Left            =   0
      TabIndex        =   0
      Top             =   840
      Width           =   2055
      Begin VB.CommandButton cmdCompare 
         Caption         =   "Launch Signature Scan"
         Height          =   375
         Index           =   1
         Left            =   135
         TabIndex        =   10
         Top             =   2340
         Width           =   1815
      End
      Begin VB.CommandButton cmdAddSignature 
         Caption         =   "Add Sel to Signatures"
         Height          =   375
         Left            =   120
         TabIndex        =   9
         Top             =   1845
         Width           =   1815
      End
      Begin VB.CommandButton cmdCompare 
         Caption         =   "Run Diff"
         Height          =   375
         Index           =   0
         Left            =   120
         TabIndex        =   8
         Top             =   1170
         Width           =   1815
      End
      Begin VB.CommandButton cmdExport 
         Caption         =   "Save Snap 2"
         Height          =   375
         Index           =   1
         Left            =   135
         TabIndex        =   6
         Top             =   660
         Width           =   1815
      End
      Begin VB.CommandButton cmdExport 
         Caption         =   "Save Snap 1"
         Height          =   375
         Index           =   0
         Left            =   120
         TabIndex        =   4
         Top             =   180
         Width           =   1815
      End
      Begin VB.Line Line1 
         BorderColor     =   &H00404040&
         BorderStyle     =   6  'Inside Solid
         DrawMode        =   7  'Invert
         Index           =   1
         X1              =   180
         X2              =   1800
         Y1              =   2835
         Y2              =   2835
      End
      Begin VB.Line Line1 
         BorderColor     =   &H00404040&
         BorderStyle     =   6  'Inside Solid
         DrawMode        =   7  'Invert
         Index           =   0
         X1              =   180
         X2              =   1800
         Y1              =   1665
         Y2              =   1665
      End
   End
   Begin VB.Label lblMore 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "More"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   11220
      TabIndex        =   16
      Top             =   120
      Width           =   795
   End
   Begin VB.Label Label2 
      Caption         =   "IDA "
      Height          =   255
      Left            =   720
      TabIndex        =   13
      Top             =   120
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Sqlite DB"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   255
      Left            =   300
      TabIndex        =   1
      Top             =   540
      Width           =   675
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "mnuPopup"
      Begin VB.Menu mnuCheckAll 
         Caption         =   "Select All"
         Index           =   0
      End
      Begin VB.Menu mnuCheckAll 
         Caption         =   "Select None"
         Index           =   1
      End
      Begin VB.Menu mnuCheckAll 
         Caption         =   "Invert Selection"
         Index           =   2
      End
      Begin VB.Menu mnuCheckAll 
         Caption         =   "Remove Selected"
         Index           =   3
      End
      Begin VB.Menu mnuCheckAll 
         Caption         =   "Remove UnSelected"
         Index           =   4
      End
   End
   Begin VB.Menu mnuMorePopup 
      Caption         =   "mnuMorePopup"
      Begin VB.Menu mnuOpenIDB 
         Caption         =   "Open IDB"
      End
      Begin VB.Menu mnuNewIDA 
         Caption         =   "Disasm New"
      End
      Begin VB.Menu mnuSpacer 
         Caption         =   "-"
         Visible         =   0   'False
      End
      Begin VB.Menu mnuODBCDrivers 
         Caption         =   "32bit ODBC Drivers"
         Visible         =   0   'False
      End
      Begin VB.Menu mnuSqlLiteBrowser 
         Caption         =   "SqlLite Browser"
         Visible         =   0   'False
      End
   End
End
Attribute VB_Name = "frmImporter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Author: david@idefense.com <david@idefense.com, dzzie@yahoo.com>
'
'License: Copyright (C) 2005 iDefense.com, A Verisign Company
'
'         This program is free software; you can redistribute it and/or modify it
'         under the terms of the GNU General Public License as published by the Free
'         Software Foundation; either version 2 of the License, or (at your option)
'         any later version.
'
'         This program is distributed in the hope that it will be useful, but WITHOUT
'         ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
'         FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
'         more details.
'
'         You should have received a copy of the GNU General Public License along with
'         this program; if not, write to the Free Software Foundation, Inc., 59 Temple
'         Place, Suite 330, Boston, MA 02111-1307 USA

'3.6.14 - added support 64 bit disassemblies (still requires 32 bit IDA)
'2.6.25 - finally got working again (last was ida 6.9)
'       - switched to sqllite odbc driver - http://www.ch-werner.de/sqliteodbc/
'       - moved into ida compare main exe. now uses IDASvr plugin (ida 7-9)

Public cn As New Connection
Public dlg As New clsCmnDlg
Dim x64Mode As Boolean
Public abort As Boolean

Enum ExportModes
    compare1 = 0
    Compare2 = 1
    SignatureMode = 2
    TmpMode = 3
End Enum

'HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI\ODBC Drivers\SQLite3 ODBC Driver = Installed
    'D:\>reg query "HKLM\SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI\ODBC Drivers" /f "SQLite3 ODBC Driver"
    'HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI\ODBC Drivers
    '    SQLite3 ODBC Driver    REG_SZ    Installed
    
'HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI\SQLite3 ODBC Driver
    'D:\>reg query "HKLM\SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI" /f "SQLite3 ODBC Driver" /k
    'HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI\SQLite3 ODBC Driver
    'End of search: 1 match(es) found.

'Shell "C:\WINDOWS\SYSWOW64\ODBCAD32.EXE", vbNormalFocus

Function TestDriver()
    Dim base As String

    On Error Resume Next

    base = App.path & IIf(isIde(), ",\..\", "") & "\db\blank.db"

    If Not FileExists(base) Then
        MsgBox "Could not find blank database" & vbCrLf & vbCrLf & base, vbInformation
        Exit Function
    End If
    
    If Not OpenDB(cn, base) Then
        MsgBox "Do you have the 32bit ODBC Sqllite driver installed?" & vbCrLf & vbCrLf & "http://www.ch-werner.de/sqliteodbc/"
    Else
        cn.Close
    End If
    
End Function

Private Sub cmdAbort_Click()
    abort = True
End Sub
 
Private Sub cmdAddSignature_Click()
    If Not ida.isUp Then
        MsgBox "Not connected to an IDA instance", vbInformation
        Exit Sub
    End If
    DoExport SignatureMode
End Sub

Private Sub cmdCompare_Click(index As Integer)

    On Error GoTo hell
    Dim pth As String
    Dim exe As String
    Dim r As Long, rr As Long

    If index = 0 Then
        pth = txtDB
    Else
        pth = App.path & IIf(isIde(), "\..\", "") & "\db\signatures.db"
        If Not fso.FileExists(pth) Then
            MsgBox "Could not find signature database?: " & vbCrLf & vbCrLf & pth, vbInformation
            Exit Sub
        End If
        If OpenDB(cn, pth) Then
            r = cn.Execute("Select count(autoid) as cnt from signatures")!cnt
            If r < 1 Then
                MsgBox "You have not yet added any signatures to scan for", vbInformation
                cn.Close
                Exit Sub
            End If
            cn.Execute "Delete from tmp" 'clear out any old tmp data
            cn.Close
        End If
    End If

    If Not fso.FileExists(pth) Then
        MsgBox "Could not locate DB, """ & pth & """", vbInformation
        Exit Sub
    End If

    If index = 1 Then     'save current db functions to tmp table for compare
        DoExport TmpMode  'to make sure saved and in same db as signatures so cheat
        
    End If

    frmMain.DoDbLoad pth, (index = 1)
    Unload Me

    Exit Sub

hell:
    MsgBox Err.Description

End Sub

Private Sub cmdExport_Click(index As Integer)
    Dim mode As ExportModes

    If Not ida.isUp Then
        MsgBox "Not connected to an IDA instance", vbInformation
        Exit Sub
    End If
    
    mode = index
    DoExport mode
    
End Sub

 
Private Sub cmdNew_Click()
    Dim pth As String
    Dim base As String
    Dim a As Long
    
    On Error GoTo hell
    
    base = App.path & IIf(isIde(), ",\..\", "") & "\db\blank.db"

    If Not fso.FileExists(base) Then
        MsgBox "Could not find blank database to use:" & vbCrLf & vbCrLf & _
               base, vbInformation
        Exit Sub
    End If

    pth = dlg.SaveDialog(CustomFilter, , "Save new DB as..", , Me.hwnd)
    If Len(pth) = 0 Then Exit Sub
    If LCase(VBA.right(pth, 3)) <> ".db" Then pth = pth & ".db"

    If Not FileCopy2(base, pth) Then
        MsgBox "Failed to copy blank to: " & pth, vbExclamation
        Exit Sub
    End If
    
    txtDB = pth
    SaveSetting "IdaCompare", "settings", "txtdb", txtDB.Text

    Exit Sub
hell:
    MsgBox Err.Description & " " & pth
End Sub

'vb filecopy can be an asshole
Public Function FileCopy2(ByVal pvSrc, ByVal pvTarg) As Boolean
    Dim fso
    On Error GoTo hell
    Set fso = CreateObject("Scripting.FileSystemObject")    '(reference: ms Scripting Runtime)
    fso.CopyFile pvSrc, pvTarg
    FileCopy2 = True
    Exit Function
hell:
End Function


Private Sub mnuNewIDA_Click()
    On Error Resume Next
    Dim ida As String
    ida = IDAPath
    If fso.FileExists(ida) Then
        Shell ida, vbNormalFocus
    Else
        MsgBox "Could not find ida path"
    End If
End Sub

Private Sub mnuOpenIDB_Click()
    Dim dlg2 As New CCmnDlg, idb As String
    dlg2.SetCustomFilter "IDA Database (*.i64)", "*.i64"
    idb = dlg2.OpenDialog()
    If Len(idb) = 0 Then Exit Sub
    ShellExecute Me.hwnd, "open", idb, vbNullString, vbNullString, 1
End Sub

Private Sub cmdSelect_Click()
    Dim pth As String
    pth = dlg.OpenDialog(AllFiles, , "Select existing db to export to", Me.hwnd)
    If Len(pth) = 0 Then Exit Sub
    txtDB = pth
    SaveSetting "IdaCompare", "settings", "txtdb", txtDB.Text
End Sub

Private Sub cmdSelectIDB_Click()
    Dim hwnd As Long
    hwnd = ida.SelectIDAInstance(, False, True)
    If hwnd = 0 Then Exit Sub
    ida.ipc.RemoteHWND = hwnd
    txtIDB = ida.loadedFile()
    x64Mode = ida.is64BitMode
    LoadFuncMap
End Sub

Private Sub Form_Load()
    On Error Resume Next
    
    mnuPopup.Visible = False
    mnuMorePopup.Visible = False
    lv.SetColumnHeaders "n,Start,End,Size,Name*,Refs", "600,1605,1650,1020,2790,1440"
    
    TestDriver
    dlg.SetCustomFilter "Sqllite Database (*.db)", "*.db"
    Me.Visible = True
    
    txtDB = frmMain.currentMDB
    If Not fso.FileExists(txtDB) Then txtDB = GetSetting("IdaCompare", "settings", "txtdb")
    If Not fso.FileExists(txtDB) Then txtDB = Empty
    
    If ida.isUp Then
        txtIDB = ida.loadedFile()
        If Len(txtIDB) > 0 Then
            x64Mode = ida.is64BitMode
            LoadFuncMap
        End If
    End If
    
End Sub

Sub LoadFuncMap()

    Dim li As ListItem
    Dim cnt As Long, i As Long
    Dim startPos As String, endPos As String, j As Long
    Dim path As String, tmp, X() As String, count As Long
    
    Me.caption = "Getting function map..."
    Me.refresh
    
    StartBenchMark
    path = ida.funcMap(count)
    If Len(path) = 0 Then
        MsgBox "Dumping function map failed from: " & txtIDB, vbInformation
        Exit Sub
    End If
    
    lv.Clear
    lv.LockUpdate = True
    pb.Max = count
    pb.value = 0
    Me.caption = "Loading stats for " & count & " functions..."
    abort = False
    
    i = FreeFile
    Open path For Input As i
    Do
         Line Input #i, tmp
         If Len(tmp) > 0 Then
            X = Split(tmp, ",") '    'i, name.c_str(), ua1, ua2, (fu->end_ea - fu->start_ea), fu->referers);
            If CLng(X(4)) > 60 Then
                lv.AddItem X(0), X(2), X(3), X(4), X(1), X(5)  '9 sec for 550 func
'                Set li = lv2.ListItems.add(, , x(0)) 'still took 9 seconds w/direct access confirmed with second lv
            Else
                j = j + 1
            End If
         End If
         pb.value = pb.value + 1
         DoEvents
         If abort Then Exit Do
    Loop While Not EOF(i)
    Close i
    
    lv.LockUpdate = False
    pb.value = 0
    Me.caption = Me.caption & IIf(x64Mode, " (64 bit)", " (32 Bit)") & " - ignored " & j & " func < 60 bytes - " & EndBenchMark
    
End Sub

Sub DoExport(mode As ExportModes)

    On Error GoTo hell

    Dim leng As Long, start As String, sql As String, fields As String
    Dim buf() As Byte, cnt As Long, funcIndex As Long
    Dim pth As String, asm As String, idb As String, tbl As String, bytes As String
    Dim li As ListItem, selLv As ListView

    Set selLv = lv.currentLV

    If mode >= SignatureMode Then
        pth = App.path & "\db\signatures.db"
    Else
        pth = txtDB
    End If

    If Not fso.FileExists(pth) Then
        MsgBox "File not found, select mdb: " & pth, vbInformation
        Exit Sub
    End If

    OpenDB cn, pth

    Select Case mode
        Case compare1:      tbl = "a"
        Case Compare2:      tbl = "b"
        Case SignatureMode: tbl = "signatures"
        Case TmpMode:       tbl = "tmp"
    End Select

    If mode < SignatureMode Then
        cnt = cn.Execute("Select count(autoid) as cnt from " & tbl)!cnt
        If cnt > 0 Then
            idb = cn.Execute("Select idb from " & tbl & " limit 1")!idb
            If MsgBox("Table " & tbl & " is already full of data overwrite?" & vbCrLf & vbCrLf & idb, vbYesNo) = vbNo Then
                Exit Sub
            Else
                cn.Execute "Delete from " & tbl
            End If
        End If
    ElseIf mode = TmpMode Then
        cn.Execute "Delete from " & tbl
    End If

    pb.value = 0
    pb.Max = selLv.ListItems.count

    idb = ida.loadedFile()
    If Len(idb) > 254 Then idb = right(idb, 254) 'in case its a binary of the same name but different paths...
    If Len(idb) = 0 Then idb = "sample" 'maybe they loaded a lib file?

    fields = "idb,disasm,i,leng,fname,startEA"
    
    Const dump_addr = 1
    Const dump_bytes = 2
    Const dump_comments = 4
    
    For Each li In selLv.ListItems
        
        funcIndex = li.Text
        If mode = SignatureMode And Not li.selected Then GoTo nextOne

1        leng = li.subItems(3)
2        start = li.subItems(1)
'3        bytes = Replace(ida.dumpFuncBytes(funcIndex), "\x", " ") 'we dont ever use these to slow on large binaries..
4        asm = Replace(ida.dumpFunc(funcIndex, 0), Chr(&HD) & Chr(&HD), Chr(&HD))
         sql = ado_buildInsert(tbl, fields, idb, asm, li.Text, leng, li.subItems(4), start)
5        cn.Execute sql

nextOne:
6        pb.value = pb.value + 1
    Next

    pb.value = 0
    If mode <> TmpMode Then MsgBox "Functions saved to db", vbInformation

Exit Sub
hell: MsgBox "Error in DoExport (sql copied): Line: " & Erl() & " Description: " & Err.Description
      Clipboard.SetText sql
End Sub


Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    cn.Close
    Set dlg = Nothing
End Sub

Private Sub Label1_Click()

    On Error Resume Next
    Dim idba, idbb, curidb, sigMode

    cn.Close
    curidb = ida.loadedFile

    If Not fso.FileExists(txtDB) Then
        MsgBox "There is no database currently active", vbInformation
        Exit Sub
    Else
        If Not OpenDB(cn, txtDB) Then Exit Sub
    End If

    sigMode = IIf(InStr(1, cn.ConnectionString, "signatures.mdb", vbTextCompare) > 0, True, False)

    If Not sigMode Then
        idba = cn.Execute("Select idb from a limit 1")!idb
        idbb = cn.Execute("Select idb from b limit 1")!idb

        MsgBox "Cur_Idb: " & curidb & vbCrLf & _
               "Table 1: " & idba & vbCrLf & _
               "Table 2: " & idbb, vbInformation

    Else
        MsgBox "Cur_Idb: " & curidb & vbCrLf & "Signature scan mode", vbInformation
    End If


End Sub

Function OpenDB(cn As Connection, pth) As Boolean
    
    On Error Resume Next
    
    Dim cnstr As String
    
    cn.Close
    Err.Clear
    
    If Len(pth) > 0 Then
         cn.ConnectionString = ado_BuildConnectionString(db_sqllite, pth)
    End If
    
    cn.Open
    OpenDB = IIf(Err.Number <> 0, False, True)
    
    'If Err.Number <> 0 Then
    '    MsgBox Err.Description
    'End If
    
End Function

Private Sub lblMore_Click()
    PopupMenu mnuMorePopup
End Sub

Private Sub lv_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then PopupMenu mnuPopup
End Sub

Private Sub mnuCheckAll_Click(index As Integer)

    Dim li As ListItem
    Dim i As Long
    
    For i = lv.ListItems.count To 1 Step -1
        Set li = lv.ListItems(i)
        Select Case index
            Case 0: li.selected = True
            Case 1: li.selected = False
            Case 2: li.selected = Not li.selected
            Case 3: If li.selected Then lv.ListItems.Remove li.index
            Case 4: If Not li.selected Then lv.ListItems.Remove li.index
        End Select
    Next

End Sub

Private Sub mnuODBCDrivers_Click()
    On Error Resume Next
    Shell "cmd.exe /c start http://www.ch-werner.de/sqliteodbc/", vbHide
End Sub
 
Private Sub mnuSqlLiteBrowser_Click()
    On Error Resume Next
    Shell "cmd.exe /c start https://sqlitebrowser.org/", vbHide
End Sub

Private Sub txtDB_OLEDragDrop(data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error Resume Next
    txtDB = data.Files(1)
End Sub
